panelapp/api/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.urls import path, include
from django.conf import settings
from drf_yasg.views import get_schema_view
from drf_yasg import openapi
from .permissions import ReadOnlyPermissions

schema_view = get_schema_view(
    openapi.Info(
        title="PanelApp API",
        default_version=settings.REST_FRAMEWORK["DEFAULT_VERSION"],
        description="PanelApp API",
        terms_of_service="https://panelapp.genomicsengland.co.uk/policies/terms/",
        contact=openapi.Contact(email="panelapp@genomicsengland.co.uk"),
        license=openapi.License(name="MIT License"),
    ),
    patterns=["api"],
    validators=["flex", "ssv"],
    public=True,
    permission_classes=(ReadOnlyPermissions,),
)

app_name = "api"
urlpatterns = [path("v1/", include("api.v1.urls", namespace="v1"))]

panelapp/panels/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.conf.urls import url

from django.views.generic import RedirectView
from .views import AdminView
from .views import AdminUploadGenesView
from .views import AdminUploadPanelsView
from .views import AdminUploadReviewsView
from .views import EntitiesListView
from .views import CreatePanelView
from .views import EntityDetailView
from .views import GenePanelView
from .views import PanelsIndexView
from .views import UpdatePanelView
from .views import PromotePanelView
from .views import PanelAddEntityView
from .views import PanelEditEntityView
from .views import PanelMarkNotReadyView
from .views import GenePanelSpanshotView
from .views import EntityReviewView
from .views import MarkEntityReadyView
from .views import DownloadPanelTSVView
from .views import DownloadPanelVersionTSVView
from .views import MarkGeneNotReadyView
from .views import ComparePanelsView
from .views import CompareGeneView
from .views import CopyReviewsView
from .views import DownloadAllGenes
from .views import DownloadAllPanels
from .views import ActivityListView
from .views import DownloadAllSTRs
from .views import DownloadAllRegions
from .views import GeneDetailRedirectView
from .views import RedirectGenesToEntities
from .views import OldCodeURLRedirect
from .ajax_views import ClearPublicationsAjaxView
from .ajax_views import ClearPhoenotypesAjaxView
from .ajax_views import ClearModeOfPathogenicityAjaxView
from .ajax_views import ClearSourcesAjaxView
from .ajax_views import ClearSingleSourceAjaxView
from .ajax_views import DeletePanelAjaxView
from .ajax_views import DeleteEntityAjaxView
from .ajax_views import RejectPanelAjaxView
from .ajax_views import ApprovePanelAjaxView
from .ajax_views import UpdateEntityTagsAjaxView
from .ajax_views import UpdateEntityMOPAjaxView
from .ajax_views import UpdateEntityMOIAjaxView
from .ajax_views import UpdateEntityPhenotypesAjaxView
from .ajax_views import UpdateEntityPublicationsAjaxView
from .ajax_views import UpdateEntityRatingAjaxView
from .ajax_views import DeleteEntityEvaluationAjaxView
from .ajax_views import GetEntityCommentFormAjaxView
from .ajax_views import DeleteEntityCommentAjaxView
from .ajax_views import SubmitEntityCommentFormAjaxView
from .ajax_views import ApproveEntityAjaxView


app_name = "panels"

entity_regex = "[\w\-\.\$\~\@\#\ ]+"
entity_types = "gene|str|region"

urlpatterns = [
    url(r"^$", PanelsIndexView.as_view(), name="index"),
    url(r"^compare/$", ComparePanelsView.as_view(), name="compare_panels_form"),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        ComparePanelsView.as_view(),
        name="compare",
    ),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)/(?P<gene_symbol>[\w\-]+)$",
        CompareGeneView.as_view(),
        name="compare_genes",
    ),
    url(
        r"^copy/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        CopyReviewsView.as_view(),
        name="copy_reviews",
    ),
    url(r"^(?P<pk>[0-9]+)/$", GenePanelView.as_view(), name="detail"),
    url(r"^(?P<pk>[0-9]+)/update$", UpdatePanelView.as_view(), name="update"),
    url(r"^(?P<pk>[0-9]+)/promote$", PromotePanelView.as_view(), name="promote"),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/add".format(types=entity_types),
        PanelAddEntityView.as_view(),
        name="add_entity",
    ),
    url(r"^(?P<pk>[0-9]+)/delete$", DeletePanelAjaxView.as_view(), name="delete_panel"),
    url(r"^(?P<pk>[0-9]+)/reject$", RejectPanelAjaxView.as_view(), name="reject_panel"),
    url(
        r"^(?P<pk>[0-9]+)/approve$",
        ApprovePanelAjaxView.as_view(),
        name="approve_panel",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download/(?P<categories>[0-4]+)/$",
        DownloadPanelTSVView.as_view(),
        name="download_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download_version/$",
        DownloadPanelVersionTSVView.as_view(),
        name="download_old_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_name>{})/$".format(entity_regex),
        RedirectGenesToEntities.as_view(),
        name="redirect_previous_structure",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/$".format(
            types=entity_types, regex=entity_regex
        ),
        GenePanelSpanshotView.as_view(),
        name="evaluation",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/edit$".format(
            types=entity_types, regex=entity_regex
        ),
        PanelEditEntityView.as_view(),
        name="edit_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/review$".format(
            types=entity_types, regex=entity_regex
        ),
        EntityReviewView.as_view(),
        name="review_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkEntityReadyView.as_view(),
        name="mark_entity_as_ready",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_not_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkGeneNotReadyView.as_view(),
        name="mark_entity_as_not_ready",
    ),
    # AJAX endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/delete$".format(
            types=entity_types, regex=entity_regex
        ),
        DeleteEntityAjaxView.as_view(),
        name="delete_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/approve$".format(
            types=entity_types, regex=entity_regex
        ),
        ApproveEntityAjaxView.as_view(),
        name="approve_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_sources$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSourcesAjaxView.as_view(),
        name="clear_entity_sources",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_source/(?P<source>(.*))/$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSingleSourceAjaxView.as_view(),
        name="clear_entity_source",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_phenotypes$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPhoenotypesAjaxView.as_view(),
        name="clear_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_publications$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPublicationsAjaxView.as_view(),
        name="clear_entity_publications",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_mode_of_pathogenicity$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearModeOfPathogenicityAjaxView.as_view(),
        name="clear_entity_mode_of_pathogenicity",
    ),
    # AJAX Review endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_tags/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityTagsAjaxView.as_view(),
        name="update_entity_tags",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_rating/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityRatingAjaxView.as_view(),
        name="update_entity_rating",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_moi/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOIAjaxView.as_view(),
        name="update_entity_moi",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_mop/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOPAjaxView.as_view(),
        name="update_entity_mop",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_phenotypes/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPhenotypesAjaxView.as_view(),
        name="update_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_publications/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPublicationsAjaxView.as_view(),
        name="update_entity_publications",
    ),
    url(

panelapp/panels/models/codes.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
"""Enums used in the app"""

from enum import Enum


class ProcessingRunCode(Enum):
    PROCESSED = 0
    PROCESS_BACKGROUND = 1

panelapp/panels/forms/activity.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms


class ActivityFilterForm(forms.Form):
    panel = forms.ChoiceField(required=False, choices=list)
    version = forms.ChoiceField(required=False, choices=list)
    entity = forms.ChoiceField(
        label="Gene or Genomic Entity Name", required=False, choices=list
    )
    date_from = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )
    date_to = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )

    def __init__(self, *args, **kwargs):
        panels = kwargs.pop("panels")
        versions = kwargs.pop("versions")
        entities = kwargs.pop("entities")

        super().__init__(*args, **kwargs)

        self.fields["panel"].choices = [("", "Panel")] + list(panels)

        if versions:
            self.fields["version"].choices = [("", "Panel Version")] + list(versions)
        else:
            self.fields["version"].widget.attrs = {"disabled": "disabled"}

        if entities:
            self.fields["entity"].choices = [("", "")] + list(entities)
        else:
            self.fields["entity"].widget.attrs = {"disabled": "disabled"}

panelapp/panels/forms/geneready.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms
from panels.models import GenePanelEntrySnapshot


class GeneReadyForm(forms.ModelForm):
    """
    This class marks Gene as Ready and also adds a comment if it was provided.
    It also saves a new evidence with the current Gene status as an evidence.
    Additionally, we add save a TrackRecord to note this change, and record an activity
    """

    ready_comment = forms.CharField(
        label="Comment (eg What decisions are being made?)",
        required=False,
        widget=forms.Textarea,
    )

    class Meta:
        model = GenePanelEntrySnapshot
        fields = ("comments",)

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

        original_fields = self.fields
        self.fields = {}
        self.fields["ready_comment"] = original_fields.get("ready_comment")

    def save(self, *args, **kwargs):
        self.instance.mark_as_ready(
            self.request.user, self.cleaned_data["ready_comment"]
        )

panelapp/panels/templates/panels/compare/compare_panels.html
{% extends "default.html" %}
{% load staticfiles %}
{% load panel_helpers %}
{% block content %}

  <ol class="breadcrumb">
    <li>
      <a href="{% url 'panels:index' %}">Panels</a>
    </li>
    <li class="active">Compare panels</li>
  </ol>

  <h1>
    <p class="text-muted normal add-label-margin" style="font-size: 18px">Comparing panels</p>
    {% block title %}“{{ panel_1.level4title.name }}” and “{{ panel_2.level4title.name }}”{% endblock %}
  </h1>

  {% if show_copy_reviews %}
    <a href="{% url 'panels:copy_reviews' panel_1.panel_id panel_2.panel_id %}">Copy reviews from “{{ panel_1.level4title.name }}” to “{{ panel_2.level4title.name }}”</a>
  {% endif %}

  {% if panel_1 and panel_2 %}
  <div class="table-responsive add-top-margin">
    <table class="table table-bordered" data-module="filterable-table">
      <thead>
        {% include "panels/compare/compare_table_heading.html" %}
        <tr class="if-no-js-hide table-header-secondary">
          <td colspan="100">
            <form>
              <label for="panel-filter" class="rm">Filter genes</label>
              <div class="input-group">
                <input id="panel-filter" type="text" class="form-control normal js-filter-table-input" placeholder="Filter genes">
                <span class="input-group-addon js-filter-table-count" data-singular="gene" data-plural="genes">
                  0 genes
                </span>
              <div>
            </form>
          </td>
        </tr>
      </thead>
      <tbody>
        {% for gene in comparison %}
          <tr>
            <td class="text-right">
              {% if gene.1 %}
                <h4 class="remove-top-margin remove-bottom-margin">
                  <span style="font-size: 16px" class="gel-banner {{ gene.1|gene_list_class }}" title="{{ gene.1|gene_list_name }}">
                    {{ gene.1|gene_list_short_name }}
                  </span> <a href="{% url 'panels:evaluation' gene.1.panel.panel_id 'gene' gene.0 %}" class="link-inherit gel-text {{ gene.1|gene_list_class }} js-open-on-submit">{{ gene.0 }}</a>
                </h4>
                {{ gene.1.evaluation.count }} review{{gene.1.evaluation.count|pluralize}}
              {% endif %}
            </td>
            <td class="text-center">
              {% if gene.1 and gene.2 %}
                <a class="btn btn-link btn-xs" href="{% url 'panels:compare_genes' gene.1.panel.panel_id gene.2.panel.panel_id gene.0 %}">Compare</a>
              {% endif %}
            </td>
            <td>
              {% if gene.2 %}
                <h4 class="remove-top-margin remove-bottom-margin">
                  <a href="{% url 'panels:evaluation' gene.2.panel.panel_id 'gene' gene.0 %}" class="link-inherit gel-text {{ gene.2|gene_list_class }} js-open-on-submit">{{ gene.0 }}</a> <span style="font-size: 12px" class="gel-banner {{ gene.2|gene_list_class }}" title="{{ gene.2|gene_list_name }}">
                    {{ gene.2|gene_list_short_name }}
                  </span>
                </h4>
                {{ gene.2.evaluation.count }} review{{gene.2.evaluation.count|pluralize}}
              {% endif %}
            </td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
  {% endif %}
  {% include "panels/compare/compare_panels_form.html" %}
{% endblock %}

panelapp/panels/templates/panels/compare/compare_panels_form.html
<div class="modal" id="compare-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
  <form action="{% url 'panels:compare_panels_form' %}" method="post" class="modal-dialog form">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="myModalLabel">Compare panels</h4>
      </div>
      <div class="modal-body">
        {% csrf_token %}
        {% for field in form %}
          <div class="form-group">
            {{ field.label_tag }}
            <div class="add-label-margin">{{ field }}</div>
          </div>
        {% endfor %}
      </div>
      <div class="modal-footer">
        <input type="submit" class="btn btn-primary" value="Compare panels">
      </div>
    </div>
  </form>
</div>

panelapp/panels/templates/panels/compare/compare_table_heading.html
<tr class="table-header">
  <th style="width: 46%" class="text-right">
    {% include "panels/compare/compare_table_panel_heading.html" with panel=panel_1 only %}
  </th>
  <th style="width: 8%;" class="text-center">
    <button type="button" class="btn btn-default" data-toggle="modal" data-target="#compare-modal">
      Edit
    </button>
  </th>
  <th style="width: 46%">
    {% include "panels/compare/compare_table_panel_heading.html" with panel=panel_2 only %}
  </th>
</tr>

panelapp/panels/templates/panels/compare/compare_table_panel_heading.html
<h4 class="remove-top-margin add-label-margin">
  <a href="{% url 'panels:detail' panel.panel_id %}">
    {{ panel.level4title.name }}
  </a>
</h4>
<span class="normal">{% if panel.level4title.level3title %}Level 3: {{ panel.level4title.level3title }}{% endif %}<br />{% if panel.level4title.level2title %}Level 2: {{ panel.level4title.level2title }}{% endif %}<br />Version {{ panel.major_version }}.{{ panel.minor_version }}</span>

panelapp/panels/templates/panels/compare/copy_reviews.html
{% extends "default.html" %}
{% load staticfiles %}
{% load panel_helpers %}

{% block content %}
    <ol class="breadcrumb">
        <li><a href="{% url 'panels:index' %}">Panels</a></li>
        <li><a href="{% url 'panels:compare' panel_1.panel_id panel_2.panel_id %}">“{{ panel_1.level4title.name }}” &amp; “{{ panel_2.level4title.name }}”</a></li>
        <li class="active">Copy reviews</li>
    </ol>

    <h1>Copy reviews</h1>
    <div class="row">
        <div class="col-md-8 add-top-margin add-bottom-margin">
            <p class="lead">For the {{comparison|length}} gene{{comparison|pluralize}} that appear in both panels, copy reviews from <b>“{{ panel_1.level4title.name }}” to “{{ panel_2.level4title.name }}”</b>. If a reviewer has reviewed the same gene in both panels, their reviews and comments will not be copied.</p>
        </div>
    </div>

    <div class="table-responsive">
        <table class="table table-bordered" data-module="filterable-table">
            <thead>
                <tr class="table-header">
                    <th>Gene</th>
                    <th style="width: 43%">
                        Reviews to be copied<br />
                        <a href="{% url 'panels:detail' panel_1.panel_id %}">
                            {{ panel_1.level4title.name }}
                        </a>
                    </th>
                    <th style="width: 43%">
                        Existing reviews<br />
                        <a href="{% url 'panels:detail' panel_2.panel_id %}">
                            {{ panel_2.level4title.name }}
                        </a>
                    </th>
                </tr>
            </thead>
            <tbody>
                {% for entry in comparison %}
                    <tr>
                        <th class="text-right">
                            <h3 class="remove-top-margin remove-bottom-margin">
                                {{ entry.0 }}
                            </h3>
                            <a href="{% url 'panels:compare_genes' panel_1.panel_id panel_2.panel_id entry.0 %}" class="normal">Compare</a>
                        </th>
                        <td>
                            {% if entry.1.evaluation.all %}
                            <ul class="remove-bottom-margin">
                                {% for ev in entry.1.evaluation.all %}
                                    <li>{{ ev.user.get_reviewer_name }}</li>
                                {% endfor %}
                            </ul>
                            {% endif %}
                        </td>
                        <td>
                            {% if entry.2.evaluation.all %}
                            <ul class="remove-bottom-margin">
                                {% for ev in entry.2.evaluation.all %}
                                    <li>{{ ev.user.get_reviewer_name }}</li>
                                {% endfor %}
                            </ul>
                            {% endif %}
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
            <tfoot>
                <tr class="table-header">
                    <td colspan="3" class="text-center">
                        <form class="add-top-margin add-bottom-margin" action="{% url 'panels:copy_reviews' panel_1.panel_id panel_2.panel_id %}" method="post">
                            {% csrf_token %}
                            {% for field in form %}
                                {{ field }}
                            {% endfor %}
                            <input type="submit" class="btn btn-lg btn-primary" value="Copy all reviews" />
                        </form>
                    </td>
                </tr>
            </tfoot>
        </table>
    </div>
{% endblock %}